% === testWienerSubtr.m === .  WienerSubtraction ===
%
% 1)   
% 2)    ,  Ds
% 3)  ,  Dn
% 4)        SNR0
% 5)    
% 6)    
% 
%% === 1.    ===
filename = 'odyn2sim';       %   
IS = 9900;                   %     (- )
SNR0 = 10;                   %   -
Tave = 0.025;                %    
tresh = 0.1;                 %   
%% === 2.    ,  Ds ===
[x,fs]=wavread('odyn2sim');       %   
t = 0:1/fs:(length(x)-1)/fs;      %   
x = x/max(abs(x));                %   
% ===       (VAD) ===
Nave = round(Tave*fs);            % -  
ak = 1/Nave*ones(Nave,1); bk = 1; % - . 
env = sqrt(filter(ak,bk,x.^2));    %  
vad = (sign(env-tresh) + 1)/2;    % VAD 
Ds = var(nonzeros(x.*vad));       %      VAD
%% === 3.  ,  Dn ===
n = randn(length(x),1);           %  
Dn = var(n);                      %   
%% === 4.        SNR0 ===
SNR = 10*log10(Ds/Dn);            %  snr
k0 = 10^(0.05*(SNR - SNR0));      % .-
y = x + k0*n;                     %  
y = y/max(abs(y))*0.99;           % .
%% === 5.     ===
enhw=WienerSubtraction(y,fs,'w',IS);
enhw = enhw/max(abs(enhw))*0.99;           % .
enhs=WienerSubtraction(y,fs,'s',IS);
enhs = enhs/max(abs(enhs))*0.99;           % .
%% === 6.     ===
% : , , . . -, . SS -
figure;
subplot(2,2,1); plot(t,x);
title(''); xlabel(', '); ylabel('');
subplot(2,2,3); plot(t,y);
title(' + '); xlabel(', '); ylabel('');
subplot(2,2,2); plot(t,enhw);
title('. -'); xlabel(', '); ylabel('');
subplot(2,2,4); plot(t,enhs);
title('..'); xlabel(', '); ylabel('');

% ===  ===
wt = 0.032;                         % window length in sec
wl = fix(wt*fs)+mod(fix(wt*fs),2);  % window length im samples (must be even)
NFFT=2*wl;                          % FFT size is twice the window length

figure;
[B,f,T] = spectrogram(x,hanning(wl),wl-20,NFFT,fs);
imagesc(T,f,20*log10(abs(B)));axis xy;colorbar
title('');
xlabel('Time (sec)');ylabel('Frequency (Hz)');

figure;
[B,f,T] = spectrogram(y,hanning(wl),wl-20,NFFT,fs);
imagesc(T,f,20*log10(abs(B)));axis xy;colorbar
title(' + ');
xlabel('Time (sec)');ylabel('Frequency (Hz)');

figure;
[B,f,T] = spectrogram(enhw,hanning(wl),wl-20,NFFT,fs);
imagesc(T,f,20*log10(abs(B)));axis xy;colorbar
title(' ');
xlabel('Time (sec)');ylabel('Frequency (Hz)');

figure;
[B,f,T] = spectrogram(enhs,hanning(wl),wl-20,NFFT,fs);
imagesc(T,f,20*log10(abs(B)));axis xy;colorbar
title(' ');
xlabel('Time (sec)');ylabel('Frequency (Hz)');